function editBody(prefs) {
  var contentFrame = document.getElementById("content-frame");
  var editor = contentFrame.getEditor(contentFrame.contentWindow);
  editor.QueryInterface(Components.interfaces.nsIHTMLEditor);
  editor.QueryInterface(Components.interfaces.nsIPlaintextEditor);
  editor.QueryInterface(Components.interfaces.nsIEditorMailSupport);
  editor.beginTransaction();
  var rv = true;
  try {
    var compHtml = gCurrentIdentity.composeHtml;
    if (prefs.work!=PASTE) {
      editor.insertTextWithQuotations(prefs.phrase);
      /*if (compHtml) {
        editor.insertHTML(prefs.phrase);
        
      }
      else {
        editor.insertText(prefs.phrase);
      }*/
    }
    else {
      var str = "";
      if (prefs.bq!="") {
        str = replaceAll(prefs.bq,prefs);
        if (compHtml) {
          editor.insertHTML(str+"<br />");
        }
        else {
          editor.insertText(str+"\n");
        }
      }
      editor.pasteAsQuotation(1);
      if (prefs.aq!="") {
        str = replaceAll(prefs.aq,prefs);
        if (compHtml) {
          editor.insertHTML("<br />"+str+"<br />");
        }
        else {
          editor.insertText("\n"+str+"\n");
        }
      }
    }
  }
  catch(ex) {
    rv = false;
  }
  //editor.rewrap(true);
  editor.endTransaction();
  return rv;
}

function editSubj(newSubj) {
  var subTB = document.getElementById('msgSubject');
  if (subTB!=null) {
    subTB.value = newSubj;
  }
}

function editTo(prefs) {
  if (prefs.operation==REPLY) {
    var toTB = document.getElementById('addressCol2#1');
    if (toTB!=null) {
      toTB.value = prefs.replyto!=""?prefs.replyto:prefs.to;
      document.getElementById('addressCol1#1').selectedIndex = 0;
    }  
  }
  else if (prefs.operation==REPLYALL) {
    if (prefs.news2!="")
      parseAndAddAddresses2(prefs.news2,"addr_newsgroups",prefs.news);
    AddRecipient("addr_to",prefs.replyto!=""?prefs.replyto:prefs.to);       
    parseAndAddAddresses2(prefs.recipients,"addr_cc",gCurrentIdentity.email);
    parseAndAddAddresses2(prefs.cc,"addr_cc",gCurrentIdentity.email);
  }
    
  /*var toTB = document.getElementById('addressCol2#1');
  if (toTB!=null) {
    toTB.value = newTo;
  }*/ 
}

function parseAndAddAddresses2(addressText, recipientType,toRemove)
{
  try{
  // strip any leading >> characters inserted by the autocomplete widget
  var strippedAddresses = addressText.replace(/.* >> /, "");
  var hdrParser = Components.classes["@mozilla.org/messenger/headerparser;1"].getService(Components.interfaces.nsIMsgHeaderParser);
  var addresses = {};
  var names = {};
  var fullNames = {};
  var numAddresses = hdrParser.parseHeadersWithArray(strippedAddresses, addresses, names, fullNames);
  if (numAddresses > 0)
  {
    var num = 0;
    for (i=0; i<numAddresses; i++) {
      fullNames.value[i-num] = fullNames.value[i];
      if (addresses.value[i]==toRemove) {
        num++;
      }
    }
    numAddresses-=num;
    fullNames.value[numAddresses] = null;
    // we need to set up our own autocomplete session and search for results

    setupAutocomplete(); // be safe, make sure we are setup
    if (!gAutomatedAutoCompleteListener)
      gAutomatedAutoCompleteListener = new AutomatedAutoCompleteHandler();

    gAutomatedAutoCompleteListener.init(fullNames.value, numAddresses, recipientType);
  }
  }catch(ex){alert("UUUUUUUUUUU "+ex)};
}

function easyquote_add(event) {
  try{
  var foc = (event.type=="focus");
  if (foc || (event.type=="click" && event.button==1) || event.type=="keypress" || 
      event.target==document.getElementById("easyquote_curr")) {
    var prefs = new easyquotePrefs();
    prefs.loadTmp();
    if (!foc || prefs.operation!=CURRMSG) {
      prefs.load();
      var currentphrase = prefs.phrase;
      if (currentphrase!=null && currentphrase.length>0 && gCurrentIdentity!=null) {
        if (prefs.operation!=NEWMSG && prefs.operation!=CURRMSG) {
          editSubj(prefs.rts+prefs.subj);
          editTo(prefs);
          SetComposeWindowTitle();
        }
        if (prefs.work!=PASTE)
          adjustPhrase(prefs);
        editBody(prefs);
        prefs.resetTmp();
        document.getElementById("content-frame").contentWindow.focus();
      }
    }
  }
  }catch(ex){alert(ex);}
}

function easyquote_init2() {
  var oContext = document.getElementById('msgcomposeWindow');
  if (oContext!=null) {
    //oContext.setAttribute("onload", ""+ oContext.getAttribute("onload")+"; alert('quiii'); easyquote_add();");
    oContext.addEventListener("focus",easyquote_add,false);
  }
  oContext = document.getElementById('content-frame');
  if (oContext!=null) {
    oContext.addEventListener("click",easyquote_add,false);
  }
}

/*function onl() {
  var msgCC = document.getElementById("msgComposeContext");
  if (msgCC!=null) {
    msgCC.addEventListener("popupshowing",easyquote_collapse_if_necessary2,false);
  }     
}

function easyquote_collapse_if_necessary2() {
  var prefs = new easyquotePrefs();
  prefs.loadTmp();
  try{
  document.getElementById("easyquote_sep").collapsed = prefs.operation!=CURRMSG || prefs.phrase=="";
  //document.getElementById("easyquote_curr").collapsed = prefs.operation!=CURRMSG || prefs.phrase=="";
  }catch(ex) {alert("HHHHHHHHHHHH "+ex.message);}
}*/

function preprocessPhrase(phrase) {
  phrase = phrase.replace(/\r\n/gi,"\n");
  phrase = phrase.replace(/<br {0,}\/{0,1}>/gi,"\n");
  return phrase.replace(/\t/gi,"    ");
}

function postprocessPhrase(phrase) {
  //phrase = phrase.replace(/\n/gi,"<br />");
  return phrase.replace(/\t/gi,"&nbsp;&nbsp;&nbsp;&nbsp;");  
}

const QUOTE_ALL=0;
const DONT_QUOTE_FIRST=1;
const DONT_QUOTE_LAST=2;
const DONT_QUOTE_FIRST_AND_LAST=3;

function adjustPhrase(prefs) {
  try{
  prefs.phrase = preprocessPhrase(prefs.phrase);
  var qstate = QUOTE_ALL;
  if (prefs.operation!=CURRMSG) {
    prefs.bq = replaceAll(prefs.bq,prefs);
    prefs.aq = replaceAll(prefs.aq,prefs);
    var newphr="";
    if (prefs.bq.length>0) {
      newphr = prefs.bq+"\n";
      qstate = DONT_QUOTE_FIRST;
    }
    newphr+=prefs.phrase+"\n";
    if (prefs.aq.length>0) {
      newphr +=prefs.aq+"\n";
      if (qstate==DONT_QUOTE_FIRST)
        qstate = DONT_QUOTE_FIRST_AND_LAST;
      else
        qstate = DONT_QUOTE_LAST;
    }
    prefs.phrase = newphr;
  }
  else  
    prefs.phrase+="\n";
  if (prefs.wc>0) {
    prefs.phrase = rewrap(prefs.phrase,prefs.wc,prefs.qs,prefs.qs2+"\n",qstate);
  }
  else {
    prefs.phrase = quoteText(prefs.phrase,prefs.qs,prefs.qs2,qstate);
  }
  if (gCurrentIdentity.composeHtml) 
    prefs.phrase = postprocessPhrase(prefs.phrase);
  }catch(ex) {alert("222222222222222 "+ex.message);}
}

function quoteText(toquote,qs,qs2,qstate) {
  var splitted = toquote.split("\n");
  var newphr = "",i;
  var lastline = qstate>=DONT_QUOTE_LAST?splitted.length-2:splitted.length-1;
  var firstline = (qstate==DONT_QUOTE_FIRST || qstate==DONT_QUOTE_FIRST_AND_LAST)?1:0;
  for (i=0; i<splitted.length; i++) {
    if (i>=firstline && i<lastline)
      newphr+=(qs+splitted[i]+qs2+"\n");
    else
      newphr+= splitted[i]+"\n";
  }
  return newphr;
  /*var startIdx = 0,dimSegm;
  var newphr = "",segment, cont = true;
  do {
    dimSegm = toquote.indexOf("\n",startIdx)-startIdx;
    if (dimSegm<0) {
      dimSegm = prefs.phrase.length-startIdx;
      cont = false;
    }
    segment = prefs.phrase.substr(startIdx,dimSegm);
    startIdx+=dimSegm+1;
    newphr += (prefs.qs+segment+"\n");
  }
  while(cont);  */
  
}

function rewrap(s,tWidth,qs,breakStr,qstate) {
  var newString="", begin = "", i, lines=s.split("\n"),wc = tWidth+qs.length;
  try{
  var lastline = qstate>=DONT_QUOTE_LAST?lines.length-2:lines.length-1;
  var firstline = (qstate==DONT_QUOTE_FIRST || qstate==DONT_QUOTE_FIRST_AND_LAST)?1:0;
  var normtWidth = tWidth-qs.length-breakStr.length+1;
  var sptWidth = tWidth;
  for(i=0;i<lines.length; i++){
    if (i>=firstline && i<lastline)
      tWidth = normtWidth;
    else
      tWidth = sptWidth;
    if(lines[i].length>tWidth){
      var str= lines[i];
      while(str.length>tWidth){
        var pos = getLastSpaceIndex(str.substr(0, tWidth));
          if (pos == -1) {
            pos = getFirstSpaceIndex(str)
            if (pos ==-1)
              break;
          }
          pos++;
          if (i>=firstline && i<lastline) {
            begin = qs+str.substr(0,pos);
            begin = insertBreak(begin,breakStr,wc);
          }
          else
            begin = str.substr(0,pos)+"\n";
          newString+=begin;
          str=str.substr(pos,str.length-pos);
      }
      if (i>=firstline && i<lastline) {
        begin = qs+str;
        begin = insertBreak(begin,breakStr,wc);
      }
      else
        begin = str+"\n";
      newString+=begin;
    }
    else{
      if (i>=firstline && i<lastline) {
        begin = qs+lines[i];
        begin = insertBreak(begin,breakStr,wc);
      }
      else
        begin = lines[i]+"\n";
      newString+=begin;
    }
  }
  }catch(ex) {alert(ex.message);}
  return newString; 
}

function insertBreak(begin, end, wc) {
  if (gCurrentIdentity.composeHtml || begin.length>=wc || end=="\n") {
    return begin+end;
  }
  else {
    var i;
    wc-=begin.length;
    var arr = begin.match(/\t/gi);
    if (arr!=null && arr.length>0)
      wc-=(arr.length*3);
    for (i=0; i<wc; i++) {
      begin+=' ';
    }
    return begin+end;
  }
}

function getLastSpaceIndex(s) {
  var lsi = s.length-1;
  while(lsi>=0) {
    if (s.charAt(lsi)==' ' || s.charAt(lsi)=='\t' || s.charAt(lsi)=='\0' || s.charAt(lsi)=='\r' || s.charAt(lsi)=='\v') {
      return lsi;
    }
    lsi--;
  }
  return -1;
}

function getFirstSpaceIndex(s) {
  var lsi = 0;
  while(lsi<s.length) {
    if (s.charAt(lsi)==' ' || s.charAt(lsi)=='\t' || s.charAt(lsi)=='\0' || s.charAt(lsi)=='\r' || s.charAt(lsi)=='\v') {
      return lsi;
    }
    lsi++;
  }
  return -1;
}

function replaceAll(a,prefs) {
  a = a.replace(/%author/gi, getAuthorName(prefs.to));
  a = a.replace(/%date/gi, prefs.date);
  arr = a.match(/\{[^\}]{0,}%news[^\}]{0,}\}/gi);
  if (arr!=null) {
    for (i=0; i<arr.length; i++) {
      if (prefs.news!="") {
        a = a.replace(arr[i],arr[i].substr(1,arr[i].length-2));
      }
      else {
        a = a.replace(arr[i],"");
      }
    }
  }
  a = a.replace(/%news/gi,prefs.news);
  a = a.replace(/%id/gi,prefs.id);
  return a.replace(/%subject/gi, prefs.subj);
}

function getAuthorName(auth) {
  var strippedAddresses = auth.replace(/.* >> /, "");
  var hdrParser = Components.classes["@mozilla.org/messenger/headerparser;1"].getService(Components.interfaces.nsIMsgHeaderParser);
  var addresses = {};
  var names = {};
  var fullNames = {};
  var numAddresses = hdrParser.parseHeadersWithArray(strippedAddresses, addresses, names, fullNames);
  if (numAddresses>0) {
    if (names.value[0]!="")
      return names.value[0];
    else if (addresses.value[0]!="") 
      return addresses.value[0];
    else
      return fullNames.value[0];
  }
  else
    return auth;
}